diff --git a/main.pm b/main.pm
--- a/main.pm
+++ b/main.pm
@@ -162,11 +162,6 @@
         autotest::loadtest "tests/_check_install_source.pm";
     }
 
-    if (get_var('LIVE')) {
-        # No package set selection for lives.
-        set_var('PACKAGE_SET', "default");
-    }
-
     ## Select package set. Minimal is the default, if 'default' is specified, skip selection.
     autotest::loadtest "tests/_software_selection.pm";
 
diff --git a/templates b/templates
--- a/templates
+++ b/templates
@@ -195,6 +195,28 @@
                     },
                     {
                       machine    => { name => "64bit" },
+                      prio       => 50,
+                      product    => {
+                                      arch    => "x86_64",
+                                      distri  => "fedora",
+                                      flavor  => "Workstation-dvd_ostree-iso",
+                                      version => "*",
+                                    },
+                      test_suite => { name => "install_default_upload" },
+                    },
+                    {
+                      machine    => { name => "uefi" },
+                      prio       => 51,
+                      product    => {
+                                      arch    => "x86_64",
+                                      distri  => "fedora",
+                                      flavor  => "Workstation-dvd_ostree-iso",
+                                      version => "*",
+                                    },
+                      test_suite => { name => "install_default" },
+                    },
+                    {
+                      machine    => { name => "64bit" },
                       prio       => 20,
                       product    => {
                                       arch    => "x86_64",
@@ -217,6 +239,17 @@
                     },
                     {
                       machine    => { name => "64bit" },
+                      prio       => 50,
+                      product    => {
+                                      arch    => "x86_64",
+                                      distri  => "fedora",
+                                      flavor  => "Workstation-dvd_ostree-iso",
+                                      version => "*",
+                                    },
+                      test_suite => { name => "install_no_user" },
+                    },
+                    {
+                      machine    => { name => "64bit" },
                       prio       => 40,
                       product    => {
                                       arch    => "x86_64",
@@ -250,6 +283,17 @@
                     },
                     {
                       machine    => { name => "64bit" },
+                      prio       => 50,
+                      product    => {
+                                      arch    => "x86_64",
+                                      distri  => "fedora",
+                                      flavor  => "Workstation-dvd_ostree-iso",
+                                      version => "*",
+                                    },
+                      test_suite => { name => "base_selinux" },
+                    },
+                    {
+                      machine    => { name => "64bit" },
                       prio       => 40,
                       product    => {
                                       arch    => "x86_64",
@@ -282,6 +326,17 @@
                       test_suite => { name => "base_services_start" },
                     },
                     {
+                      machine    => { name => "64bit" },
+                      prio       => 50,
+                      product    => {
+                                      arch    => "x86_64",
+                                      distri  => "fedora",
+                                      flavor  => "Workstation-dvd_ostree-iso",
+                                      version => "*",
+                                    },
+                      test_suite => { name => "base_services_start" },
+                    },
+                    {
                       machine    => { name => "ARM" },
                       prio       => 42,
                       product    => {
@@ -327,6 +382,17 @@
                     },
                     {
                       machine    => { name => "64bit" },
+                      prio       => 50,
+                      product    => {
+                                      arch    => "x86_64",
+                                      distri  => "fedora",
+                                      flavor  => "Workstation-dvd_ostree-iso",
+                                      version => "*",
+                                    },
+                      test_suite => { name => "base_service_manipulation" },
+                    },
+                    {
+                      machine    => { name => "64bit" },
                       prio       => 20,
                       product    => {
                                       arch    => "x86_64",
@@ -393,6 +459,17 @@
                     },
                     {
                       machine    => { name => "64bit" },
+                      prio       => 50,
+                      product    => {
+                                      arch    => "x86_64",
+                                      distri  => "fedora",
+                                      flavor  => "Workstation-dvd_ostree-iso",
+                                      version => "*",
+                                    },
+                      test_suite => { name => "base_system_logging" },
+                    },
+                    {
+                      machine    => { name => "64bit" },
                       prio       => 30,
                       product    => {
                                       arch    => "x86_64",
@@ -437,6 +514,17 @@
                     },
                     {
                       machine    => { name => "64bit" },
+                      prio       => 50,
+                      product    => {
+                                      arch    => "x86_64",
+                                      distri  => "fedora",
+                                      flavor  => "Workstation-dvd_ostree-iso",
+                                      version => "*",
+                                    },
+                      test_suite => { name => "desktop_terminal" },
+                    },
+                    {
+                      machine    => { name => "64bit" },
                       prio       => 20,
                       product    => {
                                       arch    => "x86_64",
@@ -459,6 +547,17 @@
                     },
                     {
                       machine    => { name => "64bit" },
+                      prio       => 50,
+                      product    => {
+                                      arch    => "x86_64",
+                                      distri  => "fedora",
+                                      flavor  => "Workstation-dvd_ostree-iso",
+                                      version => "*",
+                                    },
+                      test_suite => { name => "desktop_browser" },
+                    },
+                    {
+                      machine    => { name => "64bit" },
                       prio       => 30,
                       product    => {
                                       arch    => "x86_64",
@@ -1787,6 +1886,7 @@
                       name      => "",
                       settings  => [
                         { key => "CANNED", value => "1" },
+                        { key => "PACKAGE_SET", value => "default" },
                         { key => "TEST_TARGET", value => "ISO" }
                                    ],
                       version   => "*",
@@ -1809,6 +1909,7 @@
                       name      => "",
                       settings  => [
                         { key => "LIVE", value => "1" },
+                        { key => "PACKAGE_SET", value => "default" },
                         { key => "DESKTOP", value => "gnome" },
                         { key => "TEST_TARGET", value => "ISO" }
                                    ],
@@ -1821,6 +1922,7 @@
                       name      => "",
                       settings  => [
                         { key => "LIVE", value => "1" },
+                        { key => "PACKAGE_SET", value => "default" },
                         { key => "DESKTOP", value => "kde" },
                         { key => "TEST_TARGET", value => "ISO" }
                                    ],
@@ -1884,34 +1986,49 @@
                       name      => "",
                       settings  => [
                         { key => "LIVE", value => "1" },
+                        { key => "PACKAGE_SET", value => "default" },
                         { key => "DESKTOP", value => "gnome" },
                         { key => "TEST_TARGET", value => "ISO" }
                                    ],
                       version   => "*",
-                  },
-                  {
-                    arch      => "i386",
-                    distri    => "fedora",
-                    flavor    => "KDE-live-iso",
-                    name      => "",
-                    settings  => [
-                      { key => "LIVE", value => "1" },
-                      { key => "DESKTOP", value => "kde" },
-                      { key => "TEST_TARGET", value => "ISO" }
-                                 ],
-                    version   => "*",
-                  },
-                  {
-                    arch      => "arm",
-                    distri    => "fedora",
-                    flavor    => "Minimal-raw_xz-raw.xz",
-                    name      => "",
-                    settings  => [
-                        # HDD_2 gets posted by trigger and is always set to target disk image
-                        { key => "TEST_TARGET", value => "HDD_2" }
-                                 ],
-                    version   => "*",
-                  }
+                    },
+                    {
+                      arch      => "i386",
+                      distri    => "fedora",
+                      flavor    => "KDE-live-iso",
+                      name      => "",
+                      settings  => [
+                        { key => "LIVE", value => "1" },
+                        { key => "PACKAGE_SET", value => "default" },
+                        { key => "DESKTOP", value => "kde" },
+                        { key => "TEST_TARGET", value => "ISO" }
+                                   ],
+                      version   => "*",
+                    },
+                    {
+                      arch      => "arm",
+                      distri    => "fedora",
+                      flavor    => "Minimal-raw_xz-raw.xz",
+                      name      => "",
+                      settings  => [
+                          # HDD_2 gets posted by trigger and is always set to target disk image
+                          { key => "TEST_TARGET", value => "HDD_2" }
+                                   ],
+                      version   => "*",
+                    },
+                    {
+                      arch      => "x86_64",
+                      distri    => "fedora",
+                      flavor    => "Workstation-dvd_ostree-iso",
+                      name      => "",
+                      settings  => [
+                        { key => "CANNED", value => "1" },
+                        { key => "PACKAGE_SET", value => "default" },
+                        { key => "DESKTOP", value => "gnome" },
+                        { key => "TEST_TARGET", value => "ISO" }
+                                   ],
+                      version   => "*",
+                    },
                   ],
   TestSuites   => [
                     {
diff --git a/tests/_collect_data.pm b/tests/_collect_data.pm
--- a/tests/_collect_data.pm
+++ b/tests/_collect_data.pm
@@ -7,8 +7,10 @@
     $self->root_console(tty=>3);
     assert_script_run 'top -i -n20 -b > /var/tmp/top.log', 120;
     upload_logs '/var/tmp/top.log';
-    assert_script_run 'rpm -qa --queryformat "%{NAME}\n" | sort -u > /var/tmp/rpms.log';
-    upload_logs '/var/tmp/rpms.log';
+    unless (get_var("CANNED")) {
+        assert_script_run 'rpm -qa --queryformat "%{NAME}\n" | sort -u > /var/tmp/rpms.log';
+        upload_logs '/var/tmp/rpms.log';
+    }
     assert_script_run 'free > /var/tmp/free.log';
     upload_logs '/var/tmp/free.log';
     assert_script_run 'df > /var/tmp/df.log';