diff --git a/testing/test_koji_utils.py b/testing/test_koji_utils.py
--- a/testing/test_koji_utils.py
+++ b/testing/test_koji_utils.py
@@ -63,7 +63,7 @@
         # it should throw an exception in this case.
         try:
             test_koji.nvr_to_urls(self.ref_nvr, arches = [self.ref_arch])
-        except Exception:
+        except exc.TaskotronRemoteError:
             pass
 
         listrpm_calls = stub_koji.calls('listRPMs')
@@ -77,7 +77,7 @@
 
         test_koji = koji_utils.KojiClient(stub_koji)
 
-        with pytest.raises(Exception):
+        with pytest.raises(exc.TaskotronRemoteError):
             test_koji.nvr_to_urls(self.ref_nvr, arches = [self.ref_arch])
 
 
diff --git a/testing/test_python_directive.py b/testing/test_python_directive.py
--- a/testing/test_python_directive.py
+++ b/testing/test_python_directive.py
@@ -31,7 +31,7 @@
         test_directive = python_directive.PythonDirective()
         monkeypatch.setattr(os, 'path', stub_ospath)
 
-        with pytest.raises(Exception):
+        with pytest.raises(TaskotronDirectiveError):
             test_directive.checkfile(ref_filename)
 
 
diff --git a/testing/test_runner.py b/testing/test_runner.py
--- a/testing/test_runner.py
+++ b/testing/test_runner.py
@@ -9,7 +9,7 @@
 import copy
 
 from libtaskotron import runner
-from libtaskotron.exceptions import TaskotronYamlError
+from libtaskotron import exceptions as exc
 
 
 class TestRunnerInputVerify():
@@ -47,7 +47,7 @@
 
         test_runner = runner.Runner(ref_inputspec, test_args)
 
-        with pytest.raises(TaskotronYamlError):
+        with pytest.raises(exc.TaskotronYamlError):
             test_runner._validate_input()
 
     def test_yamlrunner_fails_empty_arg(self):
@@ -60,7 +60,7 @@
 
         test_runner = runner.Runner(ref_inputspec, test_args)
 
-        with pytest.raises(TaskotronYamlError):
+        with pytest.raises(exc.TaskotronYamlError):
             test_runner._validate_input()
 
     def test_yamlrunner_fails_missing_arg(self):
@@ -73,7 +73,7 @@
 
         test_runner = runner.Runner(ref_inputspec, test_args)
 
-        with pytest.raises(TaskotronYamlError):
+        with pytest.raises(exc.TaskotronYamlError):
             test_runner._validate_input()
 
     def test_yamlrunner_fails_undefined_arg(self):
@@ -86,7 +86,7 @@
 
         test_runner = runner.Runner(ref_inputspec, test_args)
 
-        with pytest.raises(TaskotronYamlError):
+        with pytest.raises(exc.TaskotronYamlError):
             test_runner._validate_input()
 
     def test_yamlrunner_fails_input_is_string(self):
@@ -99,7 +99,7 @@
 
         test_runner = runner.Runner(ref_inputspec, test_args)
 
-        with pytest.raises(TaskotronYamlError):
+        with pytest.raises(exc.TaskotronYamlError):
             test_runner._validate_input()
 
 class TestRunnerSetup():
@@ -115,17 +115,6 @@
 
         assert test_runner.taskdata == ref_taskdata
 
-class TestRunnerPrep():
-    def test_prep_invalid_commands(self, tmpdir):
-        ref_taskdata = {'preparation': {'turboencabulator':
-                                            'reduce sinusoidal repleneration'}}
-        ref_inputdata = {}
-
-        test_runner = runner.Runner(ref_taskdata, ref_inputdata, tmpdir)
-
-        with pytest.raises(Exception):
-            test_runner.do_prep()
-
 class TestRunnerDirectiveLoader():
 
     def setup_method(self, method):
@@ -156,7 +145,7 @@
         test_runner = runner.Runner(self.ref_taskdata, self.ref_inputdata,
                                     tmpdir)
 
-        with pytest.raises(Exception):
+        with pytest.raises(exc.TaskotronYamlError):
             test_runner._load_directive(self.ref_directivename, self.ref_dir)
 
 class TestRunnerSingleAction():
@@ -193,7 +182,7 @@
 
         test_runner = runner.Runner(self.ref_taskdata, self.ref_inputdata)
 
-        with pytest.raises(Exception):
+        with pytest.raises(exc.TaskotronDirectiveError):
             test_runner.do_single_action(ref_action)
 
     def test_runner_do_single_dummy_action_pass_export(self):
@@ -249,7 +238,7 @@
 
         test_runner = runner.Runner(self.ref_taskdata, self.ref_inputdata)
 
-        with pytest.raises(Exception):
+        with pytest.raises(exc.TaskotronDirectiveError):
             test_runner.do_actions()
 
     def test_runner_do_multiple_dummy_fail(self):
@@ -259,7 +248,7 @@
 
         test_runner = runner.Runner(self.ref_taskdata, self.ref_inputdata)
 
-        with pytest.raises(Exception):
+        with pytest.raises(exc.TaskotronDirectiveError):
             test_runner.do_actions()
 
     def test_runner_do_multiple_dummy_pass_export_rendered_msg(self):
@@ -285,15 +274,15 @@
 
         test_runner = runner.Runner(self.ref_taskdata, self.ref_inputdata)
 
-        with pytest.raises(TaskotronYamlError):
+        with pytest.raises(exc.TaskotronYamlError):
             test_runner.do_actions()
 
     def test_runner_fails_missing_task(self):
         self.ref_taskdata = {}
 
         test_runner = runner.Runner(self.ref_taskdata, self.ref_inputdata)
 
-        with pytest.raises(TaskotronYamlError):
+        with pytest.raises(exc.TaskotronYamlError):
             test_runner.do_actions()
 
 