diff --git a/jobtriggers/bodhi_msg.py b/jobtriggers/bodhi_msg.py
--- a/jobtriggers/bodhi_msg.py
+++ b/jobtriggers/bodhi_msg.py
@@ -49,18 +49,26 @@
             return
 
         updatetitle = usable_message['msg']['update']['title']
-        dist_tag = usable_message['msg']['update']['release']['dist_tag']
+        arches = utils.get_arches(nvr=nvrs[0])
 
-        koji_tag = '%s-updates' % dist_tag
-        if topic.endswith('testing'):
-            koji_tag += '-testing'
+        # XXX T252
+        # only schedule koji_tag tasks for -pending tags
+        if usable_message['msg']['update']['status'] == 'pending':
+            dist_tag = usable_message['msg']['update']['release']['dist_tag']
 
-        arches = utils.get_arches(nvr=nvrs[0])
+            koji_tag = '%s-updates' % dist_tag
+            if topic.endswith('testing'):
+                koji_tag += '-testing'
+            koji_tag += '-pending'
+
+            if not len(self.queued_tags):
+                self.log.info('setting fuse (%d seconds) for koji_tag %s', config.fuse_delay, koji_tag)
+            else:
+                self.log.info('adding koji_tag %s to the fuse queue', koji_tag)
 
-        self.log.info('setting fuse (%d seconds) for koji_tag %s', config.fuse_delay, koji_tag)
-        self.queued_tags.add(koji_tag)
-        for arch in arches:
-            self.queued_arches.add(arch)
+            self.queued_tags.add(koji_tag)
+            for arch in arches:
+                self.queued_arches.add(arch)
 
         # run bodhi_id tasks for every update
         self.trigger_tasks(updatetitle, 'bodhi_id', config.bodhi_tasks, arches)
diff --git a/testing/test_bodhi_trigger.py b/testing/test_bodhi_trigger.py
--- a/testing/test_bodhi_trigger.py
+++ b/testing/test_bodhi_trigger.py
@@ -11,15 +11,16 @@
     def prepare(self, monkeypatch):
         self.ref_updatetitle = 'foo'
         self.ref_dist_tag = 'f18'
-        self.ref_koji_tag = '%s-updates' % self.ref_dist_tag
+        self.ref_koji_tag = '%s-updates-pending' % self.ref_dist_tag
         self.ref_nvr = "gnome-settings-daemon-3.6.1-1.fc18"
         self.ref_topic = 'org.fedoraproject.prod.bodhi.update.request.stable'
+        self.ref_status = 'pending'
 
         self.ref_tasks = ['bodhi_task1', 'bodhi_task2']
         self.ref_validarches = ['i386', 'x86_64']
         self.ref_blacklist_releases= ['el5', 'el6']
 
-        self._create_msg(self.ref_updatetitle, self.ref_dist_tag, self.ref_nvr, self.ref_topic)
+        self._create_msg(self.ref_updatetitle, self.ref_dist_tag, self.ref_nvr, self.ref_topic, self.ref_status)
 
         stub_hub = Bunch(config=Bunch(get=0))
         self.helper = bodhi_msg.BodhiJobTrigger(stub_hub)
@@ -34,14 +35,15 @@
         bodhi_msg.config.blacklist_releases = self.ref_blacklist_releases
         bodhi_msg.config.job_logging = False
 
-    def _create_msg(self, ref_updatetitle, ref_dist_tag, ref_nvr, ref_topic):
+    def _create_msg(self, ref_updatetitle, ref_dist_tag, ref_nvr, ref_topic, ref_status):
         self.ref_message = Bunch(body='{"msg": {"agent": "lmacken",\
                                         "update": {"submitter": "lmacken",\
                                                    "title": "%s",\
                                                    "release": {"dist_tag": "%s"},\
-                                                   "builds": [{"nvr": "%s"}]}},\
+                                                   "builds": [{"nvr": "%s"}],\
+                                                   "status": "%s"}},\
                                         "topic": "%s"}' %
-                                        (ref_updatetitle, ref_dist_tag, ref_nvr, ref_topic))
+                                        (ref_updatetitle, ref_dist_tag, ref_nvr, ref_status, ref_topic))
 
     def test_consume(self):
         self.helper.consume(self.ref_message)
@@ -58,14 +60,20 @@
     def test_consume_delayed_queues(self):
         self.helper.consume(self.ref_message)
 
-        trigger_calls = self.helper.trigger.trigger_job.calls()
-
         assert self.helper.queued_tags == set([self.ref_koji_tag])
         assert self.helper.queued_arches == set(self.ref_validarches)
 
+    def test_consume_delayed_queues_kojitag_not_pending(self):
+        ref_status = ''
+        self._create_msg(self.ref_updatetitle, self.ref_dist_tag, self.ref_nvr, self.ref_topic, ref_status)
+        self.helper.consume(self.ref_message)
+
+        assert self.helper.queued_tags == set()
+        assert self.helper.queued_arches == set()
+
     def test_consume_notwatched_topic(self):
         ref_topic = 'org.fedoraproject.pro.bodhi.update.request.randomtopic'
-        self._create_msg(self.ref_updatetitle, self.ref_dist_tag, self.ref_nvr, ref_topic)
+        self._create_msg(self.ref_updatetitle, self.ref_dist_tag, self.ref_nvr, ref_topic, self.ref_status)
 
         self.helper.consume(self.ref_message)
 
@@ -75,7 +83,7 @@
 
     def test_consume_blacklisted_release(self):
         ref_nvr = 'gnome-settings-daemon-3.6.1-1.el5'
-        self._create_msg(self.ref_updatetitle, self.ref_dist_tag, ref_nvr, self.ref_topic)
+        self._create_msg(self.ref_updatetitle, self.ref_dist_tag, ref_nvr, self.ref_topic, self.ref_status)
 
         self.helper.consume(self.ref_message)
 
@@ -85,11 +93,11 @@
 
     def test_consume_kojitag_testing(self):
         ref_topic = 'org.fedoraproject.pro.bodhi.update.request.testing'
-        self._create_msg(self.ref_updatetitle, self.ref_dist_tag, self.ref_nvr, ref_topic)
+        self._create_msg(self.ref_updatetitle, self.ref_dist_tag, self.ref_nvr, ref_topic, self.ref_status)
 
         self.helper.consume(self.ref_message)
 
-        assert self.ref_koji_tag + '-testing' in self.helper.queued_tags
+        assert 'f18-updates-testing-pending' in self.helper.queued_tags
 
     def test_delayed_consume(self):
         self.helper.queued_tags = [self.ref_koji_tag]