diff --git a/jobtriggers/koji_build_msg.py b/jobtriggers/koji_build_msg.py
--- a/jobtriggers/koji_build_msg.py
+++ b/jobtriggers/koji_build_msg.py
@@ -20,6 +20,10 @@
 
         release = usable_message['msg']['release']
         state = usable_message['msg']['new']
+        instance = usable_message['msg']['instance']
+
+        if not instance == 'primary':
+            return
 
         # filter builds
         if state != koji.BUILD_STATES['COMPLETE'] or utils.blacklist_releases(release):
diff --git a/jobtriggers/koji_tag_msg.py b/jobtriggers/koji_tag_msg.py
--- a/jobtriggers/koji_tag_msg.py
+++ b/jobtriggers/koji_tag_msg.py
@@ -46,6 +46,10 @@
 
         koji_tag = usable_message['msg']['tag']
         release = usable_message['msg']['release']
+        instance = usable_message['msg']['instance']
+
+        if not instance == 'primary':
+            return
 
         # filter tags
         if not koji_tag.endswith('pending') or utils.blacklist_releases(release):
diff --git a/testing/test_koji_build_trigger.py b/testing/test_koji_build_trigger.py
--- a/testing/test_koji_build_trigger.py
+++ b/testing/test_koji_build_trigger.py
@@ -10,13 +10,14 @@
 class TestKojiBuildCompletedJobTrigger():
     @pytest.fixture
     def prepare(self, monkeypatch):
+        self.ref_instance = 'primary'
         self.ref_new = koji.BUILD_STATES['COMPLETE']
         self.ref_name = 'stage'
         self.ref_version = '4.1.1'
         self.ref_release = '3.fc18'
         self.ref_nvr = '%s-%s-%s' % (self.ref_name, self.ref_version, self.ref_release)
 
-        self._create_msg(self.ref_new, self.ref_name, self.ref_release, self.ref_version)
+        self._create_msg(self.ref_instance, self.ref_new, self.ref_name, self.ref_release, self.ref_version)
 
         self.ref_tasks = ['koji_build_task1', 'koji_build_task2']
         self.ref_validarches = ['i386', 'x86_64']
@@ -34,17 +35,18 @@
         koji_build_msg.config.blacklist_releases = self.ref_blacklist_releases
         koji_build_msg.config.job_logging = False
 
-    def _create_msg(self, ref_new, ref_name, ref_release, ref_version):
+    def _create_msg(self, ref_instance, ref_new, ref_name, ref_release, ref_version):
         self.ref_message = Bunch(body='{"i": 1,\
                                         "msg": {"build_id": 221146,\
+                                                "instance": "%s",\
                                                 "new": %d,\
                                                 "name": "%s",\
                                                 "release": "%s",\
                                                 "version": "%s"},\
                                         "timestamp": 1359603469.21164,\
                                         "topic": "org.fedoraproject.prod.buildsys.build.state.change",\
                                         "username": "apache"}' %
-                                        (ref_new, ref_name, ref_release, ref_version))
+                                        (ref_instance, ref_new, ref_name, ref_release, ref_version))
 
     def test_consume(self):
         self.helper.consume(self.ref_message)
@@ -58,9 +60,19 @@
         assert trigger_calls[2][1] == (self.ref_nvr, koji_build_msg.ITEM_TYPE, self.ref_tasks[1], self.ref_validarches[0])
         assert trigger_calls[3][1] == (self.ref_nvr, koji_build_msg.ITEM_TYPE, self.ref_tasks[1], self.ref_validarches[1])
 
+    def test_consume_not_primary_instance(self):
+        ref_instance = 'ppc'
+        self._create_msg(ref_instance, self.ref_new, self.ref_name, self.ref_release, self.ref_version)
+
+        self.helper.consume(self.ref_message)
+
+        trigger_calls = self.helper.trigger.trigger_job.calls()
+
+        assert trigger_calls == []
+
     def test_consume_notcomplete_state(self):
         ref_new = koji.BUILD_STATES['BUILDING']
-        self._create_msg(ref_new, self.ref_name, self.ref_release, self.ref_version)
+        self._create_msg(self.ref_instance, ref_new, self.ref_name, self.ref_release, self.ref_version)
 
         self.helper.consume(self.ref_message)
 
@@ -70,7 +82,7 @@
 
     def test_consume_blacklisted_release(self):
         ref_release = '3.el5.1'
-        self._create_msg(self.ref_new, self.ref_name, ref_release, self.ref_version)
+        self._create_msg(self.ref_instance, self.ref_new, self.ref_name, ref_release, self.ref_version)
 
         self.helper.consume(self.ref_message)
 
diff --git a/testing/test_koji_tag_trigger.py b/testing/test_koji_tag_trigger.py
--- a/testing/test_koji_tag_trigger.py
+++ b/testing/test_koji_tag_trigger.py
@@ -9,6 +9,7 @@
 class TestKojiTagChangedJobTrigger():
     @pytest.fixture
     def prepare(self, monkeypatch):
+        self.ref_instance = 'primary'
         self.ref_name = 'stage'
         self.ref_version = '4.1.1'
         self.ref_release = '3.fc18'
@@ -19,7 +20,7 @@
         self.ref_arch = 'x86_64'
         self.ref_blacklist_releases= ['el5', 'el6']
 
-        self._create_msg(self.ref_name, self.ref_release, self.ref_tag, self.ref_version)
+        self._create_msg(self.ref_instance, self.ref_name, self.ref_release, self.ref_tag, self.ref_version)
 
         stub_hub = Bunch(config=Bunch(get=0))
         self.helper = koji_tag_msg.KojiTagChangedJobTrigger(stub_hub)
@@ -29,9 +30,10 @@
         koji_tag_msg.config.koji_tag_changed_tasks = self.ref_tasks
         koji_tag_msg.config.job_logging = False
 
-    def _create_msg(self, ref_name, ref_release, ref_tag, ref_version):
+    def _create_msg(self, ref_instance, ref_name, ref_release, ref_tag, ref_version):
         self.ref_message = Bunch(body='{"i": 1,\
                                         "msg": {"build_id": 221146,\
+                                                "instance": "%s",\
                                                 "name": "%s",\
                                                 "owner": "ralph",\
                                                 "release": "%s",\
@@ -42,7 +44,7 @@
                                         "timestamp": 1359603469.21164,\
                                         "topic": "org.fedoraproject.prod.buildsys.tag",\
                                         "username": "apache"}' %
-                                        (ref_name, ref_release, ref_tag, ref_version))
+                                        (ref_instance, ref_name, ref_release, ref_tag, ref_version))
 
     def test_delayed_queue(self):
         self.helper.consume(self.ref_message)
@@ -63,9 +65,19 @@
 
         assert self.helper.queued_tags == set()
 
+    def test_consume_not_primary_instance(self):
+        ref_instance = 'ppc'
+        self._create_msg(ref_instance, self.ref_name, self.ref_release, self.ref_tag, self.ref_version)
+
+        self.helper.consume(self.ref_message)
+
+        trigger_calls = self.helper.trigger.trigger_job.calls()
+
+        assert trigger_calls == []
+
     def test_consume_kojitag_not_pending(self):
         ref_tag = 'f18-updates-testing'
-        self._create_msg(self.ref_name, self.ref_release, ref_tag, self.ref_version)
+        self._create_msg(self.ref_instance, self.ref_name, self.ref_release, ref_tag, self.ref_version)
         self.helper.consume(self.ref_message)
 
         assert self.helper.queued_tags == set()
@@ -86,7 +98,7 @@
 
     def test_consume_blacklisted_release(self):
         ref_release = '3.el5.1'
-        self._create_msg(self.ref_name, ref_release, self.ref_tag, self.ref_version)
+        self._create_msg(self.ref_instance, self.ref_name, ref_release, self.ref_tag, self.ref_version)
 
         self.helper.consume(self.ref_message)
 